﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace TestIPadCookie
{
    public partial class Default : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            for (int j = 0; j < 30; ++j)
            {
                string text = string.Empty;
                string cookieString = string.Empty;
                HttpCookie cookie = new HttpCookie("ipadTest" + j.ToString().PadLeft(2, '0'));
                cookie.Expires = DateTime.Now.AddDays(1);
                for (int i = 0; i < 10000; ++i)
                {
                    text += 'c';
                    cookie.Value = text;
                    cookieString = LargeCookieModule.CookieHelper.GetSetCookieHeaderString(HttpContext.Current, cookie);
                    if (System.Text.Encoding.UTF8.GetByteCount(cookieString) >= 317)
                    {
                        break;
                    }
                }
                HttpContext.Current.Response.AppendCookie(cookie);
                HttpContext.Current.Response.Write("cookieLength=" + cookieString.Length.ToString() + "<br />");
                HttpContext.Current.Response.Write("cookieValueLength=" + text.Length.ToString()
                    + ", gap = " + Math.Abs(cookieString.Length - text.Length) + "<br />");
                HttpContext.Current.Response.Write("cookieString=" + cookieString + "<br />");
                HttpContext.Current.Response.Write("<br />");
            }
        }
    }
}