﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace WebAppLargeCookieModule
{
    public partial class Default : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            HttpContext.Current.Response.Write("UserAgent:" + HttpContext.Current.Request.UserAgent + "<br />");
            StringBuilder sb = new StringBuilder();
            int i = 0;
            // In this demo the cookieLength except value is 52
            // firefox.total:4145
            // chrome.total:4096
            // 当ipad下的时候，一旦有Cookies超过这个长度，后续Cookie会异常。
            // ipad.safari:4125、4123
            // ipad.chrome:4125、4123
            // ipad.qqbrowser:4125、4123
            for (i = 0; i < (4096-1153); ++i)
            {
                sb.Append('a');
            }
            HttpCookie cookie = new HttpCookie("Test");
            cookie.Value = sb.ToString();
            cookie.Expires = DateTime.Now.AddDays(20);
            HttpContext.Current.Response.AppendCookie(cookie);
            HttpContext.Current.Response.Write("cookieValueLength=" + i.ToString() + "<br />");
            //same cookie-name.
            //HttpCookie cookie2 = new HttpCookie("Test");
            //cookie2.Value = "hello";
            //cookie2.Expires = DateTime.Now.AddDays(1);
            //HttpContext.Current.Response.AppendCookie(cookie2);
            //HttpContext.Current.Response.Write("cookieValueLength=" + cookie2.Value.Length.ToString() + "<br />");

            Response.Write("<br />-----------(start)Page_Load create a new cookie set into the responseStream:--------------<br />");
            foreach (string key in Response.Cookies.AllKeys)
            {
                HttpCookie cookie1 = Response.Cookies[key];
                if (cookie1 != null)
                {
                    Response.Write("Page_Load.cookieName:" + cookie1.Name + "<br />");
                    Response.Write("Page_Load.cookieLength:" + cookie1.Value + "<br />");
                    Response.Write("Page_Load.GetByteCount:" + System.Text.Encoding.UTF8.GetByteCount(cookie1.Value) + "<br />");
                }
            }
            Response.Write("<br />-----------(end)Page_Load create a new cookie set into the responseStream--------------<br />");
        }
    }
}