﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace WebAppLargeCookieModule
{
    public partial class WebForm1 : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            // 测试ipad cookie极限
            // 判断是否是4096kb

            string text = string.Empty;
            string cookieString = string.Empty;
            HttpCookie cookie = new HttpCookie("ipadTest");
            cookie.Expires = DateTime.Now.AddDays(1);
            for (int i = 0; i < 10000; ++i)
            {
                text += 'm';
                cookie.Value = text;
                cookieString = LargeCookieModule.CookieHelper.GetSetCookieHeaderString(HttpContext.Current, cookie);
                if (System.Text.Encoding.UTF8.GetByteCount(cookieString) >= 4124)
                {
                    break;
                }
            }

            HttpContext.Current.Response.AppendCookie(cookie);
            HttpContext.Current.Response.Write("cookieLength=" + cookieString.Length.ToString() + "<br />");
            HttpContext.Current.Response.Write("cookieValueLength=" + text.Length.ToString() 
                + ", gap = " + Math.Abs(cookieString.Length - text.Length) + "<br />");
            HttpContext.Current.Response.Write("cookieString=" + cookieString + "<br />");

        }
    }
}